unit hiVisualShape; {    ver 2.20} 

interface

uses Kol,Share,Win,Windows,Messages;

type
  TShapeType = (stArrowRight, stArrowLeft,
                stArrowUp, stArrowDown,
                stEllipse,
                stLineHorz, stLineVert,
                stRectangle, stRectangleRound,
                stTriangleUp, stTriangleDown, stTriangleLeft, stTriangleRight
                );
type
   THIVisualShape = class(THIWin)
   private
      procedure _OnPaint( Sender: PControl; DC: HDC );
   public
      _prop_PColor:TColor;
      _prop_PWidth:integer;
      _prop_PStyle:integer;
      _prop_Color2:TColor;
      _prop_ShapeType:Byte;

    procedure Init;override;
  end;
implementation

procedure THIVisualShape.Init;
begin
  Control:= NewPaintBox(FParent).Setsize(50,50);
  Control.OnPaint:= _OnPaint;
  Inherited;
end;

procedure THIVisualShape._OnPaint;
var   PT: Integer;
begin
   with Sender.Canvas{$ifndef F_P}^{$endif} do begin
      Brush.Color := Sender.Color;
      FillRect(Sender.ClientRect);
      Pen.Color := _prop_PColor;
      Pen.PenWidth := _prop_PWidth;
      Pen.PenStyle := TPenStyle(_prop_PStyle);
      Brush.Color := _prop_Color2;
      PT := Pen.PenWidth div 2;
      case  TShapeType(_prop_ShapeType) of
         stRectangle:      Rectangle(PT,PT, sender.Width-PT, sender.Height-PT);
         stRectangleRound: RoundRect(PT,PT, sender.Width-PT, sender.Height-PT, sender.Width div 4, sender.Height div 4);
         stEllipse:        Ellipse(PT, PT, sender.Width-PT, sender.Height-PT);
         stLineHorz: begin
            MoveTo(0, sender.Height div 2);
            LineTo(sender.Width-1, sender.Height div 2);
         end;
         stLineVert: begin
            MoveTo(sender.Width div 2, 0);
            LineTo(sender.Width div 2, sender.Height-1);
         end;
         stArrowLeft: begin
            MoveTo(sender.Width-1, sender.Height div 2);
            LineTo(PT, sender.Height div 2);
            LineTo(sender.Height div 2, sender.Height-1);
            MoveTo(PT, sender.Height div 2);
            LineTo(sender.Height div 2, 0);
         end;
         stArrowRight: begin
            MoveTo(0, sender.height div 2);
            LineTo(sender.width-PT, sender.height div 2);
            LineTo(sender.width-1-(sender.height div 2), sender.height-1);
            MoveTo(sender.width-PT, sender.height div 2);
            LineTo(sender.width-1-(sender.height div 2), 0);
         end;
         stArrowUp: begin
            MoveTo(sender.width div 2, sender.height-1);
            LineTo(sender.width div 2, PT);
            LineTo(0, sender.width div 2);
            MoveTo(sender.width div 2, PT);
            LineTo(sender.width-1, sender.width div 2);
         end;
         stArrowDown: begin
            MoveTo(sender.width div 2, 0);
            LineTo(sender.width div 2, sender.height-PT);
            LineTo(0, sender.height-1-(sender.width div 2));
            MoveTo(sender.width div 2, sender.height-PT);
            LineTo(sender.width-1, sender.height-1-(sender.width div 2));
         end;
         stTriangleUp:     Polygon([MakePoint(sender.width div 2, 0), MakePoint(sender.width-1, sender.height-1), MakePoint(0, sender.height-1)]);
         stTriangleDown:   Polygon([MakePoint(0, 0), MakePoint(sender.width-1, 0), MakePoint(sender.width div 2, sender.height-1)]);
         stTriangleLeft:   Polygon([MakePoint(0, sender.height div 2), MakePoint(sender.width-1, 0), MakePoint(sender.width-1, sender.height-1)]);
         stTriangleRight:  Polygon([MakePoint(0, 0), MakePoint(sender.width-1, sender.height div 2), MakePoint(0, sender.height-1)]);
      end;
   end;
end;
end.
